'==========================================================================================================================
' Title: RemoteSpeak.vb
' Author: Terry Roussell
' Language: VBScript
' Description: This HouseBot script will build a VBscript file on a remote computer (C:\HBSpeak.vbs), execute it
'              and speak the text that is entered into the 'Phrase' property.
'              This script requires Microsofts SAPI 5.1 on the speaking computer and administrator access to the
'              remote computer. 
'              The speaking voice can changed by changing the index of the 'Voice Index' property.
'              You can discover the voices and corresponding index by running the included 'getVoices.vbs' script
'              that was included with this script and installed in the config\scripts directory. Copy the
'              'getVoices.vbs' script to your remote (speaking) computer and run it to find out the index number
'              of your installed voices.
'==========================================================================================================================

Phrase       = GetPropertyValue("Remote Speak.Phrase")
RemoteTarget = GetPropertyValue("Remote Speak.Remote Target")
Volume       = GetPropertyValue("Remote Speak.Volume")
VoiceIndex   = GetPropertyValue("Remote Speak.Voice Index")
Rate         = GetPropertyValue("Remote Speak.Rate")


A = "Set VObj = CreateObject(""SAPI.SpVoice"")" & VBCRLF & _
 "with VObj" & VBCRLF & _
     "Set .voice = .getvoices.item(" & (VoiceIndex) & ")" & VBCRLF & _
     ".Volume = " & """" & (Volume) & """" & VBCRLF & _
     ".Rate = " & """" & (Rate) & """" & VBCRLF & _
     ".speak " & """" & (Phrase) & """" & VBCRLF & _
"end with" & VBCRLF & _
 "    CreateObject(""Scripting.FileSystemObject"").DeleteFile (""C:\HBSpeak.vbs"")"


' Create the vbs on remote C$ - Requires admin access on the remote computer
CreateObject("Scripting.FileSystemObject").OpenTextFile("\\" & (RemoteTarget) & "\C$\HBSpeak.vbs",2,True).Write A

' Run the VBS through Wscript on remote machine via WMI Object Win32_Process
B = GetObject("winmgmts:\\" & (RemoteTarget) & "\root\cimv2:Win32_Process").Create("C:\windows\system32\wscript.exe ""c:\HBSpeak.vbs""", null, null, intProcessID)

